/*****************************************************************************
 * $LastChangedDate: 2011-04-22 12:24:45 -0400 (Fri, 22 Apr 2011) $
 * @file
 * @author  Jim E. Brooks  http://www.palomino3d.org
 * @brief   Module configuration.
 *//*
 * LEGAL:   COPYRIGHT (C) 2007 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE VERSION 2 (GPL 2).
 *****************************************************************************/

#ifndef PROGRAM_CONF_HH
#define PROGRAM_CONF_HH 1

#define PROGRAM_CONF program::GET_CONF()

#include "base/module.hh"
#include "base/conf_txt.hh"
using namespace base;
#include "object/module.hh"
#include "object/rotation_list.hh"
using namespace object;
#include "world/module.hh"
using namespace world;

namespace program {

////////////////////////////////////////////////////////////////////////////////
/// @brief Module configuration.
///
class Conf
{
#include "base/conf_template_txt.hh"
public:
    // Cmd-line args:
    bool                mPrintJoystick;

    // .conf:
    Milliseconds        mTimerTickFreq;             ///< program's timer-tick
    string              mSplashFontName;
    fp                  mSplashFontSize;
    Milliseconds        mSplashFadeMilliseconds;    ///< when fading begins
    Milliseconds        mSplashEndMilliseconds;     ///< when splash ends
    RotationList        mAircraftRotationList;      ///< initial orientation
    string              mCarrierModelName;
    RotationList        mCarrierRotationList;       ///< initial orientation
};
#include "base/conf_template_end.hh"

} // namespace program

#endif // PROGRAM_CONF_HH
