/*****************************************************************************
 * $LastChangedDate: 2011-04-10 17:44:55 -0400 (Sun, 10 Apr 2011) $
 * @file
 * @author  Jim E. Brooks  http://www.palomino3d.org
 * @brief   Debug (world).
 *//*
 * LEGAL:   COPYRIGHT (C) 2007 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE VERSION 2 (GPL 2).
 *****************************************************************************/

#ifndef WORLD_DEBUG_HH
#define WORLD_DEBUG_HH 1

namespace world {

/*******************************************************************************
 * Latitude should be in range  {0',..,180.0'}
 * Longitude should be in range {0',..,360.0'}
 *******************************************************************************/
#if DEBUG
#define ASSERT_LAT_LON_DEG( LAT, LON )                                  \
    MATH_EXCEPTION( FP_GE<fp>(LAT,0.0f) and FP_LE<fp>(LAT,180.0f)       \
                and FP_GE<fp>(LON,0.0f) and FP_LE<fp>(LON,360.0f),      \
                     "(lat,lon) out-of-range" )
#else
#define ASSERT_LAT_LON_DEG( LAT, LON )
#endif

} // namespace world

#endif // WORLD_DEBUG_HH
